function UnityProgress(dom) {
	this.progress = 0.0;
	this.message = "";
	this.dom = dom;

	var parent = dom.parentNode;

    // Main Div
	var background = document.createElement("div");
	background.id = "background";
	parent.appendChild(background);
	this.background = background;

    //LoaderWrapper
	var LoaderWrapper = document.createElement("div");
	LoaderWrapper.id = "LoaderWrapper";
	background.appendChild(LoaderWrapper);
	this.LoaderWrapper = LoaderWrapper;



    /*
    //SubWrapper
	var SubWrapper = document.createElement("div");
	SubWrapper.id = "SubWrapper";
	LoaderWrapper.appendChild(SubWrapper);
	this.LoaderWrapper = LoaderWrapper;
    */

    //BarWrapper
	var BarWrapper = document.createElement("div");
	BarWrapper.id = "BarWrapper";
	LoaderWrapper.appendChild(BarWrapper);
	this.BarWrapper = BarWrapper;

    //clearFirst
	var clearFirst = document.createElement("div");
	clearFirst.className = "clear";
	LoaderWrapper.appendChild(clearFirst);
	this.clearFirst = clearFirst;

    //ImgWrapper
	var ImgWrapper = document.createElement("div");
	ImgWrapper.id = "ImgWrapper";
    /*
	ImgWrapper.style.textAlign = "center";
	ImgWrapper.style.width = "45%";
	ImgWrapper.style.position= "absolute";
	ImgWrapper.style.top = "50%";
	ImgWrapper.style.left = "50%";
	ImgWrapper.style.transform = "translate(-50%, -50%)";
    */
	BarWrapper.appendChild(ImgWrapper);
	this.ImgWrapper = ImgWrapper;

    //clearSecond
	var clearSecond = document.createElement("div");
	clearSecond.className = "clear";
	LoaderWrapper.appendChild(clearSecond);
	this.clearSecond = clearSecond;

    //AnimationWrapper
	var AnimationWrapper = document.createElement("div");
	AnimationWrapper.id = "AnimationWrapper";
	ImgWrapper.appendChild(AnimationWrapper);
	this.AnimationWrapper = AnimationWrapper;

    //CounterWrapper
	var CounterWrapper = document.createElement("div");
	CounterWrapper.id = "CounterWrapper";
	LoaderWrapper.appendChild(CounterWrapper);
	this.CounterWrapper = CounterWrapper;


    //Circle loader
	var bar = new ProgressBar.Circle(BarWrapper, {
	    color: '#0089b1',
	    strokeWidth: 10,
	    trailColor: '#595959',
	    trailWidth: 10,
	    duration: 1,
	    easing: "linear",
	});
	this.bar = bar;

    //Sciency Image
	var ReagenzGlas = document.createElement("img");
	ReagenzGlas.src = "TemplateData/reagenzGlas.png";
	AnimationWrapper.appendChild(ReagenzGlas);
	this.ReagenzGlas = ReagenzGlas;

    //Progress counter
	var messageArea = document.createElement("p");
	messageArea.id = "ProgressCounter";
	CounterWrapper.appendChild(messageArea);
	this.messageArea = messageArea;


    /*
	var logoImage = document.createElement("img");
	logoImage.src = "TemplateData/progresslogo.png"; 
	logoImage.style.position = "absolute";
	parent.appendChild(logoImage);
	this.logoImage = logoImage;
    */
    
    /*
	var progressFrame = document.createElement("img");
	progressFrame.src = "TemplateData/loadingbar.png"; 
	progressFrame.style.position = "absolute";
	parent.appendChild(progressFrame);
	this.progressFrame = progressFrame;
    */
    /*
	var progressBar = document.createElement("img");
	progressBar.src = "TemplateData/fullbar.png"; 
	progressBar.style.position = "absolute";
	parent.appendChild(progressBar);
	this.progressBar = progressBar;
    */

	

	this.SetProgress = function (progress)
	{
		console.log(progress);
		if (this.progress < progress)
			this.progress = progress; 
		this.messageArea.style.display = "inline";
		//this.progressFrame.style.display = "inline";
		//this.progressBar.style.display = "inline";			
		this.Update();
	}

	this.SetMessage = function (message) { 
		this.message = message; 
		this.background.style.display = "inline";

		//this.logoImage.style.display = "inline";
		//this.progressFrame.style.display = "none";
	    //this.progressBar.style.display = "none";	
		//this.ReagenzGlas.style.display = "inline";
		this.Update();
	}

	this.Clear = function () {
	    this.progress = 1;
	    bar.animate(this.progress);
	    this.messageArea.textContent = (this.progress * 100).toFixed(0) + " %";
	    console.log("CLEAR: " + (this.progress * 100).toFixed(0) + " %");
		this.background.style.display = "none";
	    //this.logoImage.style.display = "none";
		//this.ReagenzGlas.style.display = "none";
		//this.progressFrame.style.display = "none";
		//this.progressBar.style.display = "none";
	}

	this.Update = function() {
        
	    this.background.style.top = this.dom.offsetTop + 'px';
		this.background.style.left = this.dom.offsetLeft + 'px';
		this.background.style.width = this.dom.offsetWidth + 'px';
		this.background.style.height = this.dom.offsetHeight + 'px';
        

		//var logoImg = new Image();
		//logoImg.src = this.logoImage.src;
		//var progressFrameImg = new Image();
		//progressFrameImg.src = this.progressFrame.src;

        /*
		this.logoImage.style.top = this.dom.offsetTop + (this.dom.offsetHeight * 0.5 - logoImg.height * 0.5) + 'px';
		this.logoImage.style.left = this.dom.offsetLeft + (this.dom.offsetWidth * 0.5 - logoImg.width * 0.5) + 'px';
		this.logoImage.style.width = logoImg.width+'px';
		this.logoImage.style.height = logoImg.height+'px';
        */
        /*
		this.progressFrame.style.top = this.dom.offsetTop + (this.dom.offsetHeight * 0.5 + logoImg.height * 0.5 + 10) + 'px';
		this.progressFrame.style.left = this.dom.offsetLeft + (this.dom.offsetWidth * 0.5 - progressFrameImg.width * 0.5) + 'px';
		this.progressFrame.width = progressFrameImg.width;
		this.progressFrame.height = progressFrameImg.height;
        */
        /*
		this.progressBar.style.top = this.progressFrame.style.top;
		this.progressBar.style.left = this.progressFrame.style.left;
		this.progressBar.width = progressFrameImg.width * Math.min(this.progress, 1);
		this.progressBar.height = progressFrameImg.height;
        */
		
		//this.messageArea.style.top = this.progressFrame.style.top;

		console.log("Progress: " + (this.progress * 100).toFixed(0) + " %");
        /*
		this.messageArea.style.left = 0;
		this.messageArea.style.width = '100%';
		this.messageArea.style.textAlign = 'center';
	   */

		if (this.progress < 0.98) {
		    this.messageArea.innerHTML = this.message;
		    this.messageArea.textContent = (this.progress * 100).toFixed(0) + " %";

		    bar.animate(this.progress);
		}
		else if (this.progress >= 0.98)
		{
		    this.messageArea.innerHTML = this.message;
		    this.messageArea.textContent = "99 %";

		    bar.animate(0.99);
		}
	}

	this.Update ();
}
